
#define  mrfw PORTB.B0
#define  mrbw PORTB.B1
#define  mlfw PORTD.B0
#define  mlbw PORTD.B1

long eps, x1, x2, el, cl, cc, cr, er, com, pr, der, preveps, in, ins;
unsigned short q, p, speed;


//============================================================================================

unsigned short anread(int ch)
{
         unsigned short readan;
         ADMUX = 0;
         if (ch == 0)
         {
            ADMUX |= (0 << MUX0);          // ADC1 - channel 0
         }
         else if (ch == 1)
         {
              ADMUX |= (1 << MUX0);          // ADC1 - channel 1
         }
         else if (ch == 2)
         {
              ADMUX |= (1 << MUX1);          // ADC1 - channel 2
         }
         else if (ch == 3)
         {
              ADMUX |= (1 << MUX0);          // ADC1 - channel 3
              ADMUX |= (1 << MUX1);          // ADC1 - channel 3
         }
         else if (ch == 4)
         {
              ADMUX |= (1 << MUX2);          // ADC1 - channel 4
         }
         else if (ch == 5)
         {
              ADMUX |= (1 << MUX0);          // ADC1 - channel 5
              ADMUX |= (1 << MUX2);
              }
         else if (ch == 6)
         {
              ADMUX |= (1 << MUX1);          // ADC1 - channel 6
              ADMUX |= (1 << MUX2);
         }
         else if (ch == 7)
         {
              ADMUX |= (1 << MUX0);
              ADMUX |= (1 << MUX1);          // ADC1 - channel 7
              ADMUX |= (1 << MUX2);
         }
         ADMUX |= (1 << REFS0);         // AVCC with external capacitor at AREF pin
         ADMUX |= (1 << ADLAR);
         ADCSRA = 0;
         ADCSRA |= (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0); //set clock prescaler at 128
         ADCSRA |= (1 << ADEN);         // enable ADC

         ADCSRA |= (1 << ADSC);         //start conversion
         do { PORTC = 0xFF; } while((ADCSRA, ADIF)==0);  //wait until conversion is done: until ADIF from ADCSRA is set to 1

         readan = ADCH;
         return readan;
 }


//============================================================================================
/* functie de control a motorului din stanga */
void mleft(int x)
{
     if (x > 255) x = 255;
     if (x < -255) x = -255;
      /* seteaza directia inainte */
     if (x > 2) {
        mlfw = 1;
        mlbw = 0;
        PWM2_Set_Duty(x);
     }
      /* seteaza directia inapoi */
     else if (x <- 2) {
          mlfw = 0;
          mlbw = 1;
          PWM2_Set_Duty(-x);
     }
     /* franare */
     else {
          mlfw = 1;
          mlbw = 1;
          PWM2_Set_Duty(255);
     }
}

//--------------------------------------------------------------------------------------------
 /* functie de control a motorului din dreapta */
void mright(int x)
{
     if (x > 255) x = 255;
     if (x < -255) x = -255;
     /* seteaza directia inainte */
     if (x > 2) {
        mrfw = 1;
        mrbw = 0;
        PWM1_Set_Duty(x);
     }
     /* seteaza directia inapoi */
     else if (x < -2) {
          mrfw = 0;
          mrbw = 1;
          PWM1_Set_Duty(-x);
     }
     /* franare */
     else
     {
         mrfw = 1;
         mrbw = 1;
         PWM1_Set_Duty(255);
     }
}

//--------------------------------------------------------------------------------------------
/* determina pozitia robotului in functie de input-ul de la senzori*/
int pos()
{
    long a, b, c;
    el = anread(0);
    delay_us(1000);
    cl = anread(1);
    delay_us(1000);
    cc = anread(2);
    delay_us(1000);
    cr = anread(3);
    delay_us(1000);
    er = anread(4);
    delay_us(1000);
    a = el * 100 + cl * 200 + cc * 300 + cr*  400 + er * 500;
    b = el + cl + cc + cr + er;
    /* mapeaza valoarea obtinuta in intervalul 0-400 */
    c = a/b - 100;
    return (int)c;
}


void main() {

 DDRA = 0x00;           // Set direction to be input
 DDRB = 0xFF;           // Set direction to be output
 DDRC = 0xFF;           // Set direction to be output
 DDRD = 0xFF;           // Set direction to be output

 PORTA = 0xFF;

 DDB3_bit = 1;                   // Set PORTB pin 3 as output pin for the PWM (according to datasheet)
 DDD7_bit = 1;                   // Set PORTD pin 7 as output pin for the PWM (according to datasheet)

 PWM1_Init(_PWM1_PHASE_CORRECT_MODE, _PWM1_PRESCALER_256, _PWM1_NON_INVERTED, 0);
 PWM2_Init(_PWM2_PHASE_CORRECT_MODE, _PWM2_PRESCALER_256, _PWM2_NON_INVERTED, 0);

 PWM1_Start();
 PWM2_Start();

 speed = 80;
 preveps = 0;

 do
{
         eps = pos() - 200;
         pr = eps * 3;
         der = eps - preveps;
         der = der * 80;
         preveps = eps;
         com = pr + der ;
         if (com < 0) {
                 x1 = ((200 + com) / 200) * speed;
                 mleft (x1);
                 mright (speed);
         }
         else if (com>0) {
              x2=((200-com)/200)*speed;
              mleft(speed);
              mright(x2);
         }
         else {
              mleft(speed);
              mright(speed);
         }
 }
 while(1);
}
